package Communication;

import com.google.protobuf.InvalidProtocolBufferException;
import com.google.protobuf.Message;
import meerkat.protobuf.DKGMessages;

/**
 * Created by Tzlil on 2/14/2016.
 */
public abstract class MailHandler {

    private MessageHandler messageHandler;
    public MailHandler(MessageHandler messageHandler){
        this.messageHandler = messageHandler;
    }

    public abstract Message extractMessage(DKGMessages.Mail mail);

    public void handel(DKGMessages.Mail mail){

        Message message = extractMessage(mail);
        if (message == null)
            return;

        switch (mail.getType()) {
            case SECRET:
                messageHandler.handelSecretMessage(mail.getSender(), mail.getDestination() == Network.BROADCAST
                        , message);
                break;
            case COMMITMENT:
                messageHandler.handelCommitmentMessage(mail.getSender(), mail.getDestination() == Network.BROADCAST
                        , message);
                break;
            case DONE:
                messageHandler.handelDoneMessage(mail.getSender(), mail.getDestination() == Network.BROADCAST
                        , message);
                break;
            case COMPLAINT:
                messageHandler.handelComplaintMessage(mail.getSender(), mail.getDestination() == Network.BROADCAST
                        , message);
                break;
            case ANSWER:
                messageHandler.handelAnswerMessage(mail.getSender(), mail.getDestination() == Network.BROADCAST
                        , message);
                break;
            case ABORT:
                messageHandler.handelAbortMessage(mail.getSender(), mail.getDestination() == Network.BROADCAST
                        , message);
                break;
            default:
                break;
        }


    }
    public void setMessageHandler(MessageHandler messageHandler) {
        this.messageHandler = messageHandler;
    }
}
